提问



如何在Python中引发异常以便以后可以通过except块捕获它?

最佳参考



  

如何在Python中手动抛出/引发异常?




使用最具特异性的Exception构造函数,该构造函数在语义上适合您的问题。 [48]


在您的信息中具体说明,例如:


raise ValueError('A very specific bad thing happened.')


不要提出通用例外



避免引发通用异常。为了捕获它,你将必须捕获所有其他更具体的异常子类。


问题1:隐藏错误



raise Exception('I know Python!') # Don't! If you catch, likely to hide bugs.


例如:


def demo_bad_catch():
    try:
        raise ValueError('Represents a hidden bug, do not catch this')
        raise Exception('This is the exception you expect to handle')
    except Exception as error:
        print('Caught this error: ' + repr(error))

>>> demo_bad_catch()
Caught this error: ValueError('Represents a hidden bug, do not catch this',)


问题2:赢得赶上



而更具体的渔获量不会引起一般的例外:


def demo_no_catch():
    try:
        raise Exception('general exceptions not caught by specific handling')
    except ValueError as e:
        print('we will not catch exception: Exception')


>>> demo_no_catch()
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
  File "<stdin>", line 3, in demo_no_catch
Exception: general exceptions not caught by specific handling


最佳实践:raise声明



相反,使用语义上适合您的问题的最具体的Exception构造函数。[49]


raise ValueError('A very specific bad thing happened')


它还可以方便地将任意数量的参数传递给构造函数:


raise ValueError('A very specific bad thing happened', 'foo', 'bar', 'baz') 


这些参数由Exception对象的args属性访问。例如:


try:
    some_code_that_may_raise_our_value_error()
except ValueError as err:
    print(err.args)


版画


('message', 'foo', 'bar', 'baz')    


在Python 2.5中,实际的message属性被添加到BaseException中,有利于鼓励用户子类化异常并停止使用args,但message的引入和args的原始弃用已经缩回。[50]


最佳实践:except条款



例如,在except子句中,您可能希望记录发生特定类型的错误,然后重新引发。在保留堆栈跟踪的同时执行此操作的最佳方法是使用bare raise语句。例如:


logger = logging.getLogger(__name__)

try:
    do_something_in_app_that_breaks_easily()
except AppError as error:
    logger.error(error)
    raise                 # just this!
    # raise AppError      # Don't do this, you'll lose the stack trace!


不要修改你的错误......但是如果你坚持的话。



您可以使用sys.exc_info()保留堆栈跟踪(和错误值),但这更容易出错并且在Python 2和3之间存在兼容性问题,更喜欢使用裸raise重新加注。


要解释 - sys.exc_info()返回类型,值和回溯。


type, value, traceback = sys.exc_info()


这是Python 2中的语法 - 注意这与Python 3不兼容:


    raise AppError, error, sys.exc_info()[2] # avoid this.
    # Equivalently, as error *is* the second object:
    raise sys.exc_info()[0], sys.exc_info()[1], sys.exc_info()[2]


如果您愿意,可以修改新加注的情况 - 例如为实例设置新的args:


def error():
    raise ValueError('oops!')

def catch_error_modify_message():
    try:
        error()
    except ValueError:
        error_type, error_instance, traceback = sys.exc_info()
        error_instance.args = (error_instance.args[0] + ' <modification>',)
        raise error_type, error_instance, traceback


我们在修改args时保留了整个回溯。请注意,这是不是最佳做法,并且在Python 3中它是无效语法(使兼容性更难以解决)。


>>> catch_error_modify_message()
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
  File "<stdin>", line 3, in catch_error_modify_message
  File "<stdin>", line 2, in error
ValueError: oops! <modification>


在Python 3中:[51]


    raise error.with_traceback(sys.exc_info()[2])


再次:避免手动操纵回溯。它效率低,容易出错。如果你正在使用线程和sys.exc_info,你甚至可能得到错误的回溯(特别是如果你使用异常处理控制流程 - 我个人倾向于避免的。)[52]


Python 3,异常链接



在Python 3中,您可以链接Exceptions,它可以保留回溯:


    raise RuntimeError('specific message') from error


意识到:



  • 此 允许更改引发的错误类型,

  • 与Python 2不兼容。



不推荐使用的方法:



这些可以轻松隐藏甚至进入生产代码。你想提出一个异常,并且这样做会引发异常,但不是那个意图!


在Python 2中有效,但在Python 3中没有以下内容:[53]


raise ValueError, 'message' # Don't do this, it's deprecated!


只有在旧版本的Python(2.4及更低版本)中有效,你仍然可以看到人们提高字符串:[54]


raise 'message' # really really wrong. don't do this.


在所有现代版本中,这实际上都会引发TypeError,因为你不会引发BaseException类型。如果你没有检查正确的异常,并且没有一个知道这个问题的审阅者,它可能会得到投入生产。


示例用法



我引用了Exceptions来警告消费者我的API,如果他们错误地使用它:


def api_func(foo):
    '''foo should be either 'baz' or 'bar'. returns something very useful.'''
    if foo not in _ALLOWED_ARGS:
        raise ValueError('{foo} wrong, use "baz" or "bar"'.format(foo=repr(foo)))


在apropos

时创建自己的错误类型


  我想故意犯错误,以便它会进入>



您可以创建自己的错误类型,如果要指示应用程序的特定错误,只需将异常层次结构中的相应点子类化:


class MyAppLookupError(LookupError):
    '''raise this when there's a lookup error for my app'''


和用法:


if important_key not in resource_dict and not ok_to_be_missing:
    raise MyAppLookupError('resource is missing, and that is not ok.')

其它参考1



  不要这样做。提高裸露Exception绝对是正确的事情;请参阅Aaron Hall的优秀答案。]]



不能比这更加pythonic:


raise Exception("I know python!")


如果您想了解更多信息,请参阅python的raise语句文档。[56]

其它参考2


对于常见的情况,您需要抛出异常以响应某些意外情况,并且您永远不打算捕获,而只是快速失败以使您能够从那里进行调试(如果它发生的话) - 最合乎逻辑的似乎是AssertionError:


if 0 < distance <= RADIUS:
    #Do something.
elif RADIUS < distance:
    #Do something.
else:
    raise AssertionError("Unexpected value of 'distance'!", distance)

其它参考3


在Python3中,有4种不同的语法用于rasing异常:


1. raise exception 
2. raise exception (args) 
3. raise
4. raise exception (args) from original_exception



  的 1。引发异常与2.引发异常(args)



如果使用raise exception (args)引发异常,则在打印异常对象时将打印args - 如下例所示。


  #raise exception (args)
    try:
        raise ValueError("I have raised an Exception")
    except ValueError as exp:
        print ("Error", exp)     # Output -> Error I have raised an Exception 



  #raise execption 
    try:
        raise ValueError
    except ValueError as exp:
        print ("Error", exp)     # Output -> Error 



  的 3.raise



没有任何参数的raise语句会重新引发最后一个异常。
如果您需要在捕获异常后执行某些操作然后想要重新提升它,这将非常有用。但如果之前没有例外,raise陈述引起TypeError例外。


def somefunction():
    print("some cleaning")

a=10
b=0 
result=None

try:
    result=a/b
    print(result)

except Exception:            #Output ->
    somefunction()           #some cleaning
    raise                    #Traceback (most recent call last):
                             #File "python", line 8, in <module>
                             #ZeroDivisionError: division by zero



  的 4。从original_exception 引发异常(args)



此语句用于创建异常链接,其中为响应另一个异常而引发的异常可以包含原始异常的详细信息 - 如下面的示例所示。


class MyCustomException(Exception):
pass

a=10
b=0 
reuslt=None
try:
    try:
        result=a/b

    except ZeroDivisionError as exp:
        print("ZeroDivisionError -- ",exp)
        raise MyCustomException("Zero Division ") from exp

except MyCustomException as exp:
        print("MyException",exp)
        print(exp.__cause__)


输出:


ZeroDivisionError --  division by zero
MyException Zero Division 
division by zero

其它参考4


首先阅读现有答案,这只是一个附录。


请注意,您可以使用或不使用参数引发异常。


例:


raise SystemExit


退出程序,但你可能想知道发生了什么。所以你可以使用它。


raise SystemExit("program exited")


这将在关闭程序之前将程序退出打印到stderr。